module SKEIN_TOP(
   clk, rst_n,
   init, load, fetch,
   idata, odata,
   ack, EOM
);

/************************ input / output *************************/
//{{{
input clk;
input rst_n;

input init;
input load;
input fetch;

output ack;
input EOM;

input [15:0] idata;
output [15:0] odata;
//}}}

/************************ wire ***********************************/
//{{{
wire [31:0] m0, m1, m2, m3, m4, m5, m6, m7;
wire [63:0] hash0, hash1, hash2, hash3;
wire Ld_tweak;
wire Ld_posi;

wire busy;
wire start;
//}}}


/************************ instance *******************************/
//{{{
SKEIN_INTERFACE skein_interface(
   .clk(clk), .rst_n(rst_n),
   .load(load), .fetch(fetch),
   .idata(idata), .odata(odata),
   .busy(busy), .start(start), .ack(ack),
   .m0(m0), .m1(m1), .m2(m2), .m3(m3), 
   .m4(m4), .m5(m5), .m6(m6), .m7(m7),
   .hash0(hash0[63:32]), .hash1(hash0[31:0]), .hash2(hash1[63:32]), .hash3(hash1[31:0]),
   .hash4(hash2[63:32]), .hash5(hash2[31:0]), .hash6(hash3[63:32]), .hash7(hash3[31:0]), 
   .Ld_tweak(Ld_tweak), .Ld_posi(Ld_posi));

SKEIN_CORE skein_core(
   .clk(clk), .rst_n(rst_n),
   .init(init), .busy(busy), .start(start), .EOM(EOM), 
   .msg0({m0,m1}), .msg1({m2,m3}), .msg2({m4,m5}), .msg3({m6,m7}), 
   .hash0(hash0), .hash1(hash1), .hash2(hash2), .hash3(hash3),
   .Ld_tweak(Ld_tweak), .idata(idata), .Ld_posi(Ld_posi)
);
//}}}


endmodule

// vim:fdm=marker
